%define ALD_Ver		2.0

#USE gcc-7.5.0

%define OrgName udev
%define mC_Version 1.2.4s

Name:         mC-%{OrgName}
License:      GPL LGPL
Summary:      udev - Linux userspace device management
Version:      175
Release:      %{mC_Version}.0

Source: %{OrgName}-%{version}.tar.xz

%define DestDir		/Embedded/mC/%{mC_Version}

# -----------------------------------------------------
%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}/mC/%{mC_Version}
%define _CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%endif

# -----------------------------------------------------

%if %{have_auto_local}
%define __os_install_post %{nil}
%endif

%if %{_CROSS}
%define CrossPath /cross/%{_target_cpu}
%else
%define CrossPath %{nil}
%endif

#------------------ CROSS DIR --------------------

%define target %{_arch}-linux-musl

%define _prefix /usr/mC/%{mC_Version}
%define _bindir /%{_lib}/udev
%define _sbindir /sbin
%define _libexecdir /%{_lib}/udev
%define _mandir /usr/share/man/
%define _libdir %{_prefix}/lib
%define _defaultdocdir /usr/share/doc/
%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
udev - Linux userspace device management
#-------------------------------
%package cdrom
Summary:      udev cdrom
%description cdrom
udev cdrom
#-------------------------------
%package keymap
Summary:      udev keymap
%description keymap
udev keymap
#-------------------------------
%package devel
Summary:      uClibc Libraries for the C compiler
%description devel
These libraries are needed to compile C code.
# --------------------------------------
%package doc
Summary:      doc for %{OrgName}
%description doc
doc for %{OrgName}

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}

if test -e /usr/include/linux/input-event-codes.h; then
  sed -i s:"linux/input.h":"linux/input-event-codes.h": Makefile.in
fi
sed -i s:"@libexecdir@":"@sbindir@": init/udev.service.in

sed -i s:"<sys/stat.h>":"<sys/stat.h>\n#include <sys/sysmacros.h>": libudev/libudev-device.c
sed -i s:"<sys/stat.h>":"<sys/stat.h>\n#include <sys/sysmacros.h>": libudev/libudev-device-private.c
sed -i s:"<sys/stat.h>":"<sys/stat.h>\n#include <sys/sysmacros.h>": libudev/libudev-enumerate.c
sed -i s:"<sys/stat.h>":"<sys/stat.h>\n#include <sys/sysmacros.h>": udev/udev-node.c
sed -i s:"<fcntl.h>":"<fcntl.h>\n#include <sys/sysmacros.h>": udev/udev-rules.c
sed -i s:"<sys/stat.h>":"<sys/stat.h>\n#include <sys/sysmacros.h>": udev/udevd.c
sed -i s:"<fcntl.h>":"<fcntl.h>\n#include <sys/sysmacros.h>": udev/udev-event.c
sed -i s:"<fcntl.h>":"<fcntl.h>\n#include <sys/sysmacros.h>": udev/udevadm-info.c
sed -i s:"<fcntl.h>":"<fcntl.h>\n#include <sys/sysmacros.h>": extras/cdrom_id/cdrom_id.c
sed -i s:"<fcntl.h>":"<fcntl.h>\n#include <sys/sysmacros.h>": extras/scsi_id/scsi_serial.c

sed -i s:"<sys/poll.h>":"<poll.h>": libudev/libudev-monitor.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/udev-event.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/udev-ctrl.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/udevd.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/sd-daemon.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/udevadm-settle.c
sed -i s:"<sys/poll.h>":"<poll.h>": udev/udevadm-test-builtin.c

sed -i s:"<sys/fcntl.h>":"<fcntl.h>": udev/sd-daemon.c

# ------------------- Build ------------------------------------------
%Build
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"
export CFLAGS="$OPTFLAGS -std=gnu99"
export LDFLAGS="-Wl,--gc-sections"
export CC="%{target}-gcc"
#export AR="%{target}-ar"
#export STRIP="%{target}-strip"
#export RANLIB="%{target}-ranlib"
#export NM="%{target}-nm"

#export PKG_CONFIG_LIBDIR="/usr/uC/1.0.37/static/lib/pkgconfig"

./configure \
	--prefix=%{_prefix} \
	--exec-prefix=%{_exec_prefix} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--sysconfdir=%{_sysconfdir} \
	--datadir=%{_datadir} \
	--includedir=%{_includedir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libexecdir} \
	--localstatedir=%{_localstatedir} \
	--sharedstatedir=%{_sharedstatedir} \
	--mandir=%{_mandir} \
	--infodir=%{_infodir} \
	--enable-static \
	--disable-shared \
	--disable-silent-rules \
	--disable-gtk-doc \
	--disable-gtk-doc-html \
	--disable-gtk-doc-pdf \
	--disable-libtool-lock \
	--disable-debug \
	--disable-logging \
	--disable-gudev \
	--disable-introspection \
	--disable-mtd_probe \
	--with-usb-ids-path=/usr/share/usb.ids \
	--with-pci-ids-path=/usr/share/pci.ids \
	--with-firmware-path=/usr/lib/hotplug/firmware:/lib/firmware \
  &>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
export PATH=$PATH:%{CrossPath}%{_prefix}/bin
export GCC_NoHostPath=d

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt

rm $RPM_BUILD_ROOT%{_libdir}/*.la

cp README $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING

mv $RPM_BUILD_ROOT/%{_lib}/udev/udevd $RPM_BUILD_ROOT/sbin/
mv $RPM_BUILD_ROOT%{_datadir}/doc/udev/README.keymap.txt $RPM_BUILD_ROOT%{docdir}/
mv $RPM_BUILD_ROOT%{_datadir}/gtk-doc/html/libudev $RPM_BUILD_ROOT%{docdir}/html
rm -r $RPM_BUILD_ROOT%{_datadir}/doc
rm -r $RPM_BUILD_ROOT%{_datadir}/gtk-doc


%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-target_platform=%{target}-
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%exclude /%{_lib}/udev/rules.d/60-cdrom_id.rules
%exclude /%{_lib}/udev/rules.d/95-keyboard-force-release.rules
%exclude /%{_lib}/udev/rules.d/95-keymap.rules
/etc
/%{_lib}/udev/devices
/%{_lib}/udev/rules.d

/%{_lib}/udev/accelerometer
/%{_lib}/udev/ata_id
/%{_lib}/udev/collect
/%{_lib}/udev/firmware
/%{_lib}/udev/pci-db
/%{_lib}/udev/scsi_id
/%{_lib}/udev/usb-db
/%{_lib}/udev/v4l_id
/sbin
%{docdir}/COPYING
%{docdir}/README
%{_mandir}

%files cdrom
/%{_lib}/udev/cdrom_id
/%{_lib}/udev/rules.d/60-cdrom_id.rules

%files keymap
/%{_lib}/udev/keymaps
/%{_lib}/udev/findkeyboards
/%{_lib}/udev/keyboard-force-release.sh
/%{_lib}/udev/keymap
/%{_lib}/udev/rules.d/95-keyboard-force-release.rules
/%{_lib}/udev/rules.d/95-keymap.rules
%{docdir}/README.keymap.txt

%files devel
%{_includedir}
%{_libdir}/*.a
%{_libdir}/pkgconfig
%{_datadir}/pkgconfig

%files doc
%{docdir}/html
